unit InitiateCommonControlFns;

interface

uses
  Classes, dbtables, Registry, SysUtils;

function GetComboBoxItems(const TabSheetName: string): TStringList;

implementation

uses
  DataMod, PPSysMain;


function GetComboBoxItems(const TabSheetName: string): TStringList;
var
  qryStringList : TStringList;
  CurrentTabSheetName : string;
begin
  CurrentTabSheetName := TabSheetName;
  qryStringList := TStringList.Create;
  if (CurrentTabSheetName = 'TabActivity')                 then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabBatch')               then begin
    qryStringList.Add('ID');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
    qryStringList.Add('BatchStatusID');
    qryStringList.Add('BatchStatus');
    qryStringList.Add('BillingPeriod');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierAccountID');
    qryStringList.Add('InvoiceNo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
  end
  else if (CurrentTabSheetName = 'TabBatchHistory')        then begin
    qryStringList.Add('ID');
    qryStringList.Add('BatchID');
    qryStringList.Add('BatchType');
    qryStringList.Add('BatchStatusID');
    qryStringList.Add('BatchStatus');
    qryStringList.Add('Date');
    qryStringList.Add('BillingPeriod');
    qryStringList.Add('UserID');
    qryStringList.Add('Operator');
  end
  else if (CurrentTabSheetName = 'TabBatchStatus')         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabBatchType')           then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('DataSourceTypeID');
    qryStringList.Add('DataSource');
    qryStringList.Add('ValidAccount');
    qryStringList.Add('TenderNo');
    qryStringList.Add('AccountNoName');
    qryStringList.Add('InvoiceNoName');
    qryStringList.Add('TotalRevenueName');
    qryStringList.Add('TotalPayableName');
    qryStringList.Add('TotalCreditsName');
    qryStringList.Add('OpeningBalanceName');
    qryStringList.Add('PaymentsReceivedName');
    qryStringList.Add('TotalAdjustmentsName');
    qryStringList.Add('BatchStartName');
    qryStringList.Add('BatchEndName');
    qryStringList.Add('PaymentDateName');
    qryStringList.Add('CreditsToCustomersName');
    qryStringList.Add('GSTname');
    qryStringList.Add('GSTAdjustmentName');
    qryStringList.Add('OrderNumberName');
    qryStringList.Add('RequisitionNumberName');
    qryStringList.Add('IssueDateName');
    qryStringList.Add('RoundingName');
  end
  else if (CurrentTabSheetName = 'TabCentre')              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('DepartmentID');
    qryStringList.Add('Department');
    qryStringList.Add('GroupID');
    qryStringList.Add('GroupName');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabCriticalType')        then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabCustomer')            then begin
    qryStringList.Add('ID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('FullName');
    qryStringList.Add('VNumber');
    qryStringList.Add('Address01');
    qryStringList.Add('Address02');
    qryStringList.Add('Address03');
    qryStringList.Add('Address04');
    qryStringList.Add('Address05');
    qryStringList.Add('Address06');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabDataCollectionMap')   then begin
    qryStringList.Add('DCField');
    qryStringList.Add('DCValue');
    qryStringList.Add('TransValue');
  end
  else if (CurrentTabSheetName = 'TabDataSourceDetail')    then begin
  end
  else if (CurrentTabSheetName = 'TabDataSourceType')      then begin
    qryStringList.Add('ID');
    qryStringList.Add('DataSource');
  end
  else if (CurrentTabSheetName = 'TabDepartment')          then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('GroupID');
    qryStringList.Add('GroupName');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabDestination')         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabDialledNumber')       then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabDiscount')            then begin
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
  end
  else if (CurrentTabSheetName = 'TabDubiousResolution')   then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabDubiousType')         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabDubiousValidResolution') then begin
    qryStringList.Add('ID');
    qryStringList.Add('DubiousTypeID');
    qryStringList.Add('DubiousType');
    qryStringList.Add('DubiousResolutionID');
    qryStringList.Add('Resolution');
  end
  else if (CurrentTabSheetName = 'TabElement')             then begin
    qryStringList.Add('ID');
    qryStringList.Add('ElementCode');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('ServiceGroupID');
    qryStringList.Add('PlatinumUpdate');
    qryStringList.Add('ReportGroupID');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabFunction')            then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabGroup')               then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabLocation')            then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabOrigin')              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabParameter')           then begin
    qryStringList.Add('Parm');
    qryStringList.Add('ParmField');
    qryStringList.Add('ParmText');
//    qryStringList.Add('ParmNumber');
//    qryStringList.Add('ParmDate');
    qryStringList.Add('ParmDescription');
//    qryStringList.Add('ParmUserDefined');
  end
  else if (CurrentTabSheetName = 'TabPerson')              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Person');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabRate')                then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
//    qryStringList.Add('Length');
//    qryStringList.Add('Cost');
//    qryStringList.Add('Cost100');
//    qryStringList.Add('Percentage');
    qryStringList.Add('RateDescription');
//    qryStringList.Add('Active');
//    qryStringList.Add('StartDate');
//    qryStringList.Add('EndDate');
    qryStringList.Add('LastUpdatedBy');
  end
  else if (CurrentTabSheetName = 'TabServiceID')           then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceID');
    qryStringList.Add('Service');
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('ServiceType');
    qryStringList.Add('SACC');
    qryStringList.Add('Description');
    qryStringList.Add('SupplyAccountID');
    qryStringList.Add('AccountNo');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('Customer');
    qryStringList.Add('CustomerCentreID');
    qryStringList.Add('CustomerCentre');
    qryStringList.Add('CustomerActivityID');
    qryStringList.Add('CustomerActivity');
    qryStringList.Add('CustomerElementID');
    qryStringList.Add('CustomerElement');
    qryStringList.Add('CustomerSubledgerID');
    qryStringList.Add('CustomerSubledger');
    qryStringList.Add('CentreID');
    qryStringList.Add('Centre');
    qryStringList.Add('ActivityID');
    qryStringList.Add('Activity');
    qryStringList.Add('ElementID');
    qryStringList.Add('Element');
    qryStringList.Add('SubledgerID');
    qryStringList.Add('Subledger');
    qryStringList.Add('LocationID');
    qryStringList.Add('Location');
    qryStringList.Add('PersonID');
    qryStringList.Add('Person');
    qryStringList.Add('UpEnd');
    qryStringList.Add('UpMDF');
    qryStringList.Add('DownEnd');
    qryStringList.Add('DownMDF');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabServiceSplit')        then begin
    qryStringList.Add('ID');
    qryStringList.Add('ServiceID');
    qryStringList.Add('ServiceID_Desc');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('CallPercentage');
    qryStringList.Add('RentPercentage');
    qryStringList.Add('OtherPercentage');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabServiceSystem')       then begin
    qryStringList.Add('ServiceTypeID');
    qryStringList.Add('Code');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('SystemID');
    qryStringList.Add('System');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchTypeDescription');
    qryStringList.Add('ValidAccountNumberID');
    qryStringList.Add('AccountNo');
  end
  else if (CurrentTabSheetName = 'TabServiceType')         then begin
    qryStringList.Add('ID');
    qryStringList.Add('Code');
    qryStringList.Add('Description');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('RevElementID');
    qryStringList.Add('RevenueElement');
    qryStringList.Add('ExpElementID');
    qryStringList.Add('ExpenseElement');
    qryStringList.Add('AdminFee');
    qryStringList.Add('SystemID');
    qryStringList.Add('System');
    qryStringList.Add('ExportToTims');
    qryStringList.Add('SplitService');
    qryStringList.Add('VRTServiceType');
    qryStringList.Add('ExpectedRent');
    qryStringList.Add('NoCalls');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabStatus')              then begin
    qryStringList.Add('ID');
    qryStringList.Add('Status');
    qryStringList.Add('Active');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('LastUpdatedBy');
  end
  else if (CurrentTabSheetName = 'TabSubledger')           then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('CustomerID');
    qryStringList.Add('ShipTo');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabSupplier')            then begin
    qryStringList.Add('ID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('PlatinumVendorID');
    qryStringList.Add('PlatinumUpdate');
    qryStringList.Add('VicTrack');
    qryStringList.Add('Address01');
    qryStringList.Add('System');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabSupplierServiceCode') then begin
    qryStringList.Add('ID');
    qryStringList.Add('Code');
    qryStringList.Add('AmountCategory');
    qryStringList.Add('Description');
    qryStringList.Add('TransactionTypeDesc');
    qryStringList.Add('TransactionTypeID');
    qryStringList.Add('TransactionType');
    qryStringList.Add('SupplierID');
    qryStringList.Add('SupplierName');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabSystem')              then begin
    qryStringList.Add('ID');
    qryStringList.Add('System');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabTransactionGroup')    then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
  end
  else if (CurrentTabSheetName = 'TabTransactionType')     then begin
    qryStringList.Add('ID');
    qryStringList.Add('Description');
    qryStringList.Add('TransactionGroupID');
    qryStringList.Add('TransactionGroup');
    qryStringList.Add('SystemID');
    qryStringList.Add('System');
    qryStringList.Add('StartDate');
    qryStringList.Add('EndDate');
    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabUser')                then begin
    qryStringList.Add('ID');
//    qryStringList.Add('UserLogin');
    qryStringList.Add('FirstName');
    qryStringList.Add('SurName');
//    qryStringList.Add('Password');
//    qryStringList.Add('LastLoggedOn');
//    qryStringList.Add('LastLoggedOff');
//    qryStringList.Add('Active');
  end
  else if (CurrentTabSheetName = 'TabUserFunction')        then begin
    qryStringList.Add('UserID');
    qryStringList.Add('FirstName');
    qryStringList.Add('SurName');
    qryStringList.Add('FunctionID');
    qryStringList.Add('Function');
  end
  else if (CurrentTabSheetName = 'TabValidAccount')        then begin
    qryStringList.Add('ID');
    qryStringList.Add('AccountNo');
    qryStringList.Add('BatchTypeID');
    qryStringList.Add('BatchType');
    qryStringList.Add('Active');
  end;
  Result := qryStringList;
end;    // SetComboBoxItems().

end.

