unit SysEditCustomer;

interface
                                        
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Db, DBTables;

type
  TSysEditCustomerForm = class(TForm)
    ckInvoice: TCheckBox;
    ckActive: TCheckBox;
    ckPlatinumUpdate: TCheckBox;
    ckInvoiceServices: TCheckBox;
    edtStatus: TEdit;
    edtID: TEdit;
    edtFullName: TEdit;
    lblID: TLabel;
    lblFullName: TLabel;
    edtAddress01: TEdit;
    edtAddress02: TEdit;
    edtAddress03: TEdit;
    edtAddress04: TEdit;
    edtAddress05: TEdit;
    edtAddress06: TEdit;
    lblAddress01: TLabel;
    lblAddress02: TLabel;
    lblAddress03: TLabel;
    lblAddress04: TLabel;
    lblAddress05: TLabel;
    lblAddress06: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    lblShipTo: TLabel;
    edtShipTo: TEdit;
    lblVNumber: TLabel;
    edtVNumber: TEdit;
    lblStatus: TLabel;
    lblRate: TLabel;
    edtRate: TEdit;
    edtMaxExServiceAmount: TEdit;
    lblMaxExServiceAmount_A: TLabel;
    lblMaxExServiceAmount_B: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    lAppend : boolean;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    sUserName : string;
    Original_FullName : string;
    Original_ShipTo     : string;
    Original_VNumber     : string;
    Original_Status : string;
    Original_Rate : integer;
    Original_PlatinumUpdate : boolean;
    Original_Invoice : boolean;
    Original_InvoiceServices : boolean;
    Original_Active : boolean;
    Original_Address01 : string;
    Original_Address02 : string;
    Original_Address03 : string;
    Original_Address04 : string;
    Original_Address05 : string;
    Original_Address06 : string;
    Original_MaxExServiceAmount : currency;
  protected
    procedure SetAppend(Value: boolean);
    procedure SetID(Value: string);
    procedure SetFullName(const Value: string);
    function GetFullName: string;
    procedure SetShipTo(const Value: string);
    function GetShipTo: string;
    procedure SetVNumber(const Value: string);
    function GetVNumber: string;
    procedure SetStatus(const Value: string);
    function GetStatus: string;
    procedure SetRate(const Value: integer);
    function GetRate: integer;
    procedure SetPlatinumUpdate(const Value: boolean);
    function GetPlatinumUpdate: boolean;
    procedure SetInvoice(const Value: boolean);
    function GetInvoice: boolean;
    procedure SetInvoiceServices(const Value: boolean);
    function GetInvoiceServices: boolean;
    procedure SetActive(const Value: boolean);
    function GetActive: boolean;
    procedure SetAddress01(const Value: string);
    function GetAddress01: string;
    procedure SetAddress02(const Value: string);
    function GetAddress02: string;
    procedure SetAddress03(const Value: string);
    function GetAddress03: string;
    procedure SetAddress04(const Value: string);
    function GetAddress04: string;
    procedure SetAddress05(const Value: string);
    function GetAddress05: string;
    procedure SetAddress06(const Value: string);
    function GetAddress06: string;
    procedure SetMaxExServiceAmount(const Value: currency);
    function GetMaxExServiceAmount: currency;
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property CustomerID: string write SetID;
    property FullName: string read GetFullName write SetFullName;
    property ShipTo: string read GetShipTo write SetShipTo;
    property VNumber: string read GetVNumber write SetVNumber;
    property Status: string read GetStatus write SetStatus;
    property Rate: integer read GetRate write SetRate;
    property PlatinumUpdate: boolean read GetPlatinumUpdate write SetPlatinumUpdate;
    property Invoice: boolean read GetInvoice write SetInvoice;
    property InvoiceServices: boolean read GetInvoiceServices write SetInvoiceServices;
    property Active: boolean read GetActive write SetActive;
    property Address01: string read GetAddress01 write SetAddress01;
    property Address02: string read GetAddress02 write SetAddress02;
    property Address03: string read GetAddress03 write SetAddress03;
    property Address04: string read GetAddress04 write SetAddress04;
    property Address05: string read GetAddress05 write SetAddress05;
    property Address06: string read GetAddress06 write SetAddress06;
    property MaxExServiceAmount: currency read GetMaxExServiceAmount
      write SetMaxExServiceAmount;
  public
    { Public declarations }
  end;

const
  LEN_SHIPTO   = 4;
  LEN_FULLNAME = 50;
  LEN_VNUMBER  = 8;
  LEN_STATUS   = 12;
  LEN_ADDRESS  = 255;

var
  SysEditCustomerForm: TSysEditCustomerForm;

implementation

uses
  PPSysMain, GenFns;

{$R *.DFM}

procedure TSysEditCustomerForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  ActionDescription : string;
begin
  sUserName := Trim(MainForm.OPERATORNAME);
  qFormCreate := TQuery.Create(SELF);
  qFormCreate.DatabaseName := 'dbPPdata';
  qFormCreate.SQL.Add('SELECT *');
  qFormCreate.SQL.Add('FROM tEvent');
  qFormCreate.SQL.Add('WHERE Description LIKE ''Reference%''');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    ActionDescription := UpperCase(qFormCreate.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qFormCreate.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qFormCreate.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qFormCreate.FieldByName('id').AsString;
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.Free;
  lAudit := TestForAudit('tCustomer');
end;  // FormCreate.

procedure TSysEditCustomerForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then begin
    Caption := Caption + ' (ADD)';
    edtID.Text := '';
  end  // if lAppend then begin.
  else begin
    Caption := Caption + ' (EDIT)';
  end;  // if lAppend then begin..else.
end;  // SetAppend.

procedure TSysEditCustomerForm.SetID(Value: string);
begin
  if not lAppend then edtID.Text := Value;
end;  // SetID.

procedure TSysEditCustomerForm.SetFullName(const Value: string);
begin
  Original_FullName := Trim(Value);
  edtFullName.Text := Original_FullName;
end;  // SetFullName.

function TSysEditCustomerForm.GetFullName: string;
begin
  Result := Trim(edtFullName.Text);
end;  // GetFullName.

procedure TSysEditCustomerForm.SetShipTo(const Value: string);
begin
  Original_ShipTo := Trim(Value);
  edtShipTo.Text := Original_ShipTo;
end;

function TSysEditCustomerForm.GetShipTo: string;
begin
  Result := Trim(edtShipTo.Text);
end;

procedure TSysEditCustomerForm.SetVNumber(const Value: string);
begin
  Original_VNumber := Trim(Value);
  edtVNumber.Text := Original_VNumber;
end;

function TSysEditCustomerForm.GetVNumber: string;
begin
  Result := Trim(edtVNumber.Text);
end;

procedure TSysEditCustomerForm.SetStatus(const Value: string);
begin
  Original_Status := Trim(Value);
  edtStatus.Text := Original_Status;
end;

function TSysEditCustomerForm.GetStatus: string;
begin
  Result := Trim(edtStatus.Text);
end;

procedure TSysEditCustomerForm.SetRate(const Value: integer);
begin
  Original_Rate := Value;
  edtRate.Text := IntToStr(Original_Rate);
end;

function TSysEditCustomerForm.GetRate: integer;
begin
  Result := StrToInt(edtRate.Text);
end;

procedure TSysEditCustomerForm.SetMaxExServiceAmount(const Value: currency);
begin
  Original_MaxExServiceAmount := Value;
  edtMaxExServiceAmount.Text := CurrToStr(Original_MaxExServiceAmount);
end;

function TSysEditCustomerForm.GetMaxExServiceAmount: currency;
begin
  Result := StrToCurr(edtMaxExServiceAmount.Text);
end;

procedure TSysEditCustomerForm.SetPlatinumUpdate(const Value: boolean);
begin
  Original_PlatinumUpdate := Value;
  ckPlatinumUpdate.Checked := Original_PlatinumUpdate;
end;

function TSysEditCustomerForm.GetPlatinumUpdate: boolean;
begin
  Result := ckPlatinumUpdate.Checked;
end;

procedure TSysEditCustomerForm.SetInvoice(const Value: boolean);
begin
  Original_Invoice := Value;
  ckInvoice.Checked := Original_Invoice;
end;

function TSysEditCustomerForm.GetInvoice: boolean;
begin
  Result := ckInvoice.Checked;
end;

procedure TSysEditCustomerForm.SetInvoiceServices(const Value: boolean);
begin
  Original_InvoiceServices := Value;
  ckInvoiceServices.Checked := Original_InvoiceServices;
end;

function TSysEditCustomerForm.GetInvoiceServices: boolean;
begin
  Result := ckInvoiceServices.Checked;
end;

procedure TSysEditCustomerForm.SetActive(const Value: boolean);
begin
  Original_Active := Value;
  ckActive.Checked := Original_Active;
end;

function TSysEditCustomerForm.GetActive: boolean;
begin
  Result := ckActive.Checked;
end;

procedure TSysEditCustomerForm.SetAddress01(const Value: string);
begin
  Original_Address01 := Trim(Value);
  edtAddress01.Text := Original_Address01;
end;

function TSysEditCustomerForm.GetAddress01: string;
begin
  Result := Trim(edtAddress01.Text);
end;

procedure TSysEditCustomerForm.SetAddress02(const Value: string);
begin
  Original_Address02 := Trim(Value);
  edtAddress02.Text := Original_Address02;
end;

function TSysEditCustomerForm.GetAddress02: string;
begin
  Result := Trim(edtAddress02.Text);
end;

procedure TSysEditCustomerForm.SetAddress03(const Value: string);
begin
  Original_Address03 := Trim(Value);
  edtAddress03.Text := Original_Address03;
end;

function TSysEditCustomerForm.GetAddress03: string;
begin
  Result := Trim(edtAddress03.Text);
end;

procedure TSysEditCustomerForm.SetAddress04(const Value: string);
begin
  Original_Address04 := Trim(Value);
  edtAddress04.Text := Original_Address04;
end;

function TSysEditCustomerForm.GetAddress04: string;
begin
  Result := Trim(edtAddress04.Text);
end;

procedure TSysEditCustomerForm.SetAddress05(const Value: string);
begin
  Original_Address05 := Trim(Value);
  edtAddress05.Text := Original_Address05;
end;

function TSysEditCustomerForm.GetAddress05: string;
begin
  Result := Trim(edtAddress05.Text);
end;

procedure TSysEditCustomerForm.SetAddress06(const Value: string);
begin
  Original_Address06 := Trim(Value);
  edtAddress06.Text := Original_Address06;
end;

function TSysEditCustomerForm.GetAddress06: string;
begin
  Result := Trim(edtAddress06.Text);
end;

procedure TSysEditCustomerForm.btnOkClick(Sender: TObject);
var
  qCust : TQuery;
  AmendString : TStringList;
  AuditString : TStringlist;
  sField : string;
  sValue : string;
  sTempValue : string;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  sOperatorName: string;
  slFieldList : TStringList;
  slValueList : TStringList;
  nCount : integer;
  nMaxCount : integer;
  sStarted : string;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  sOperatorName := MainForm.OPERATORNAME;
  AmendString := TStringList.Create;
  AuditString := TStringList.Create;
  if lAppend then begin
    slFieldList := TStringList.Create;
    slValueList := TStringList.Create;
    if lAudit then begin
      SetAuditStart(sUserName, AuditAction, 'tCustomer',
        sAuditInsert, sAuditField, sAuditValue);
    end;  // lAudit.
    AmendString.Add('INSERT INTO tCustomer');
    sField := '(ShipTo, FullName, VNumber, Active,';
    sStarted := Copy(ShipTo,1,LEN_SHIPTO);
    if (Length(sStarted) = 0) then sValue := 'NULL,'
    else begin
      sValue := ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('SHIPTO', '', sStarted, AuditString);
      end;
    end;
    sStarted := Copy(FullName,1,LEN_FULLNAME);
    if (Length(sStarted) = 0) then sValue := sValue + 'NULL,'
    else begin
      sValue := sValue +''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('FULLNAME', '', sStarted, AuditString);
      end;
    end;
    sStarted := Copy(VNumber,1,LEN_VNUMBER);
    if (Length(sStarted) = 0) then sValue := sValue +'NULL,'
    else begin
      sValue := sValue + ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('VNUMBER', '', sStarted, AuditString);
      end;
    end;
    if lAudit then begin
      SetAuditData('ACTIVE', '', '1', AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add('VALUES ('+ sValue +'1,');
    sField := '';
    sValue := '';

    sField := 'Status, Rate, PlatinumUpdate, Invoice, InvoiceServices,';
    sStarted := Copy(Status,1,LEN_VNUMBER);
    if (Length(sStarted) = 0) then sValue := sValue +'NULL,'
    else begin
      sValue := sValue + ''''+sStarted+''',';
      if lAudit then begin
        SetAuditData('STATUS', '', sStarted, AuditString);
      end;
    end;
    if (Rate = 0) then sTempValue := 'NULL' else sTempValue := IntToStr(Rate);
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('RATE', '', sTempValue, AuditString);
    end;
    if PlatinumUpdate then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('PLATINUMUPDATE', '', sTempValue, AuditString);
    end;
    if Invoice then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('INVOICE', '', sTempValue, AuditString);
    end;
    if InvoiceServices then sTempValue := '1' else sTempValue := '0';
    sValue := sValue + sTempValue +',';
    if lAudit then begin
      SetAuditData('INVOICESERVICES', '', sTempValue, AuditString);
    end;
    slFieldList.Add(sField);
    slValueList.Add(sValue);
    sField := '';
    sValue := '';

    sTempValue := Copy(Address01,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address01,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS01', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address02,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address02,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS02', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address03,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address03,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS03', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address04,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address04,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS04', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    sTempValue := Copy(Address05,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address05,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS05', '', sTempValue, AuditString);
      end;
    end;
    sTempValue := Copy(Address06,1,LEN_ADDRESS);
    if (Length(sTempValue) > 0) then begin
      sField := sField +' Address06,';
      sValue := sValue +' '''+sTempValue+''',';
      if lAudit then begin
        SetAuditData('ADDRESS06', '', sTempValue, AuditString);
      end;
    end;
    if (MaxExServiceAmount <> 0) then begin
      sTempValue := CurrToStr(MaxExServiceAmount);
      sField := sField +' MaxExServiceAmount,';
      sValue := sValue + sTempValue +',';
      if lAudit then begin
        SetAuditData('MAXEXSERVICEAMOUNT', '', sTempValue, AuditString);
      end;
    end;
    if (Length(sField) > 0) then begin
      slFieldList.Add(sField);
      slValueList.Add(sValue);
      sField := '';
      sValue := '';
    end;

    // Last char must be a closed parenthesis.
    sField := slFieldList[slFieldList.Count-1];
    sField := Copy(sField, 1, Length(sField)-1) + ')';
    slFieldList[slFieldList.Count-1] := sField;
    sValue := slValueList[slValueList.Count-1];
    sValue := Copy(sValue, 1, Length(sValue)-1) + ')';
    slValueList[slValueList.Count-1] := sValue;
    // Now compose the full SQL statement.
    nMaxCount := slFieldList.Count - 1;
    for nCount := 0 to nMaxCount do AmendString.Add(slFieldList[nCount]);
    for nCount := 0 to nMaxCount do AmendString.Add(slValueList[nCount]);
  end  // if lAppend then begin.
  else begin
    AmendString.Add('UPDATE tCustomer');
    sTempValue := Copy(ShipTo,1,LEN_SHIPTO);
    if lAudit then begin
      SetAuditStart(sUserName, AuditAction, 'tCustomer',
        sAuditInsert, sAuditField, sAuditValue);
      SetAuditID(Trim(edtID.Text), sAuditValue);
      if (sTempValue <> Original_ShipTo) then begin
        SetAuditData('SHIPTO', Original_ShipTo, sTempValue, AuditString);
      end;
    end;  // lAudit.
    if (Length(sTempValue)=0) then sTempValue := 'NULL,'
    else                           sTempValue := ''''+sTempValue+''',';
    sValue := 'SET ShipTo = '+ sTempValue;
    sTempValue := Copy(FullName,1,LEN_FULLNAME);
    if (sTempValue <> Original_FullName) then begin
      if lAudit then begin
        SetAuditData('FULLNAME', Original_FullName, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' FullName = '+ sTempValue;
    end;
    sTempValue := Copy(VNumber,1,LEN_VNUMBER);
    if (sTempValue <> Original_VNumber) then begin
      if lAudit then begin
        SetAuditData('VNUMBER', Original_VNumber, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' SET VNumber = '+ sTempValue;
    end;
    AmendString.Add(sValue);
    sValue := '';

    if (Rate <> Original_Rate) then begin
      if (Rate = 0) then sTempValue := 'NULL,'
      else               sTempValue := IntToStr(Rate) +',';
      if lAudit then begin
        SetAuditData('RATE', IntToStr(Original_Rate), IntToStr(Rate), AuditString);
      end;
      sValue := sValue +' Rate = '+sTempValue;
    end;
    if (MaxExServiceAmount <> Original_MaxExServiceAmount) then begin
      if (MaxExServiceAmount = 0) then sTempValue := 'NULL,'
      else                             sTempValue := CurrToStr(MaxExServiceAmount)+',';
      if lAudit then begin
        SetAuditData('MAXEXSERVICEAMOUNT', CurrToStr(Original_MaxExServiceAmount),
          CurrToStr(MaxExServiceAmount), AuditString);
      end;
      sValue := sValue +' MaxExServiceAmount = '+sTempValue;
    end;
    if PlatinumUpdate then begin
      sTempValue := '1,';
      if lAudit and  not Original_PlatinumUpdate then begin
        SetAuditData('PLATINUMUPDATE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_PlatinumUpdate then begin
        SetAuditData('PLATINUMUPDATE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' PlatinumUpdate = '+sTempValue;
    if Invoice then begin
      sTempValue := '1,';
      if lAudit and  not Original_Invoice then begin
        SetAuditData('INVOICE', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_Invoice then begin
        SetAuditData('INVOICE', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' Invoice = '+sTempValue;
    if InvoiceServices then begin
      sTempValue := '1,';
      if lAudit and  not Original_InvoiceServices then begin
        SetAuditData('INVOICESERVICES', '0', '1', AuditString);
      end;
    end
    else begin
      sTempValue := '0,';
      if lAudit and  Original_InvoiceServices then begin
        SetAuditData('INVOICESERVICES', '1', '0', AuditString);
      end;
    end;
    sValue := sValue +' InvoiceServices = '+sTempValue;
    AmendString.Add(sValue);
    sValue := '';

    sTempValue := Copy(Address01,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address01) then begin
      if lAudit then begin
        SetAuditData('ADDRESS01', Original_Address01, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address01 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address02,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address02) then begin
      if lAudit then begin
        SetAuditData('ADDRESS02', Original_Address02, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address02 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address03,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address03) then begin
      if lAudit then begin
        SetAuditData('ADDRESS03', Original_Address03, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address03 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address04,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address04) then begin
      if lAudit then begin
        SetAuditData('ADDRESS04', Original_Address04, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address04 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address05,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address05) then begin
      if lAudit then begin
        SetAuditData('ADDRESS05', Original_Address05, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address05 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;
    sTempValue := Copy(Address06,1,LEN_ADDRESS);
    if (sTempValue <> Original_Address06) then begin
      if lAudit then begin
        SetAuditData('ADDRESS06', Original_Address06, sTempValue, AuditString);
      end;
      if (Length(sTempValue)=0) then sTempValue := 'NULL,'
      else                           sTempValue := ''''+sTempValue+''',';
      sValue := sValue + ' Address06 = '+ sTempValue;
      AmendString.Add(sValue);
      sValue := '';
    end;

    // Done - remove the last trailing comma.
    with AmendString do begin
      sStarted := Strings[Count-1];
      Strings[Count-1] := Copy(sStarted,1,Length(sStarted)-1);
    end;
    AmendString.Add('WHERE id = '+ Trim(edtID.Text));
  end;  // if lAppend then begin..else.
  qCust := TQuery.Create(SELF);
  qCust.DatabaseName := 'dbPPdata';
  qCust.SQL := AmendString;
  qCust.ExecSQL;
  if lAudit then begin
    if lAppend then begin
      // Get and store the new ID for this table.
      with qCust do begin
        SQL.Clear;
        SQL.Add('SELECT ID');
        SQL.ADD('FROM tCustomer');
        SQL.Add('WHERE ShipTo LIKE '''+ ShipTo +'''');
        SQL.Add('AND Active = 1');
        Open;
        SetAuditID(FieldByName('ID').AsString, sAuditValue);
        Close;
      end;
    end;  // lAppend.
    SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
  end;
  AmendString.Free;
  AuditString.Free;
  ModalResult := mrOk;
  qCust.Free;
end;  // btnOkClick.

end.
