unit SysEditUserFunction;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, dbtables;

type
  TSysEditUserFunctionForm = class(TForm)
    edtUserLogin: TEdit;
    edtPassword: TEdit;
    edtFirstName: TEdit;
    edtSurname: TEdit;
    lblUserLogin: TLabel;
    lblPassword: TLabel;
    lblFirstName: TLabel;
    lblSurname: TLabel;
    cbF1: TCheckBox;
    cbF2: TCheckBox;
    cbF3: TCheckBox;
    cbF4: TCheckBox;
    cbF5: TCheckBox;
    cbF6: TCheckBox;
    cbF7: TCheckBox;
    cbF8: TCheckBox;
    cbF9: TCheckBox;
    cbF10: TCheckBox;
    cbF11: TCheckBox;
    cbF12: TCheckBox;
    cbF13: TCheckBox;
    cbF14: TCheckBox;
    cbF15: TCheckBox;
    cbF16: TCheckBox;
    btnOk: TButton;
    btnCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
    AmendString : TStringList;
    AuditString : TStringlist;
    slFields : TStringList;
    slValues : TStringList;
    lAppend : boolean;
    sUserName : string;
    sUserID : string;
    sFunction : string;
    lAudit : boolean;
    AuditActionUpdate : string;
    AuditActionDelete : string;
    AuditActionInsert : string;
    Original_UserLogin : string;
    Original_Password : string;
    Original_FirstName : string;
    Original_Surname : string;
    Original_ChkF1 : boolean;
    Original_ChkF2 : boolean;
    Original_ChkF3 : boolean;
    Original_ChkF4 : boolean;
    Original_ChkF5 : boolean;
    Original_ChkF6 : boolean;
    Original_ChkF7 : boolean;
    Original_ChkF8 : boolean;
    Original_ChkF9 : boolean;
    Original_ChkF10 : boolean;
    Original_ChkF11 : boolean;
    Original_ChkF12 : boolean;
    Original_ChkF13 : boolean;
    Original_ChkF14 : boolean;
    Original_ChkF15 : boolean;
    Original_ChkF16 : boolean;
  protected
    procedure SetAppend(Value: boolean);
    procedure SetUserID(Value: integer);
    function GetUserID: integer;
    procedure SetUserLogin(Value: string);
    function GetUserLogin: string;
    procedure SetPassword(Value: string);
    function GetPassword: string;
    procedure SetFirstName(Value: string);          
    function GetFirstName: string;
    procedure SetSurname(Value: string);
    function GetSurname: string;
    procedure SetFunction(Value: string);
  published
    property AppendMode: boolean read lAppend write SetAppend;
    property UserID: integer read GetUserID write SetUserID;
    property UserLogin: string read GetUserLogin write SetUserLogin;
    property Password: string read GetPassword write SetPassword;
    property FirstName: string read GetFirstName write SetFirstName;
    property Surname: string read GetSurname write SetSurname;
    property Function1To16: string read sFunction write SetFunction;
  public
    { Public declarations }
  end;

var
  SysEditUserFunctionForm: TSysEditUserFunctionForm;

implementation

uses
  DataMod, GenFns, PPSysMain;

{$R *.DFM}

procedure TSysEditUserFunctionForm.FormCreate(Sender: TObject);
var
  qFormCreate : TQuery;
  ActionDescription : string;
begin
  lAppend := False;
  AmendString := TStringList.Create;
  AuditString := TStringlist.Create;
  slFields := TStringList.Create;
  slValues := TStringList.Create;
  sUserName := Trim(MainForm.OPERATORNAME);
  sUserID := '';
  sFunction := '0000000000000000';
  qFormCreate := TQuery.Create(SELF);
  qFormCreate.DatabaseName := 'dbPPdata';
  qFormCreate.SQL.Add('SELECT *');
  qFormCreate.SQL.Add('FROM tEvent');
  qFormCreate.SQL.Add('WHERE Description LIKE ''Reference%''');
  qFormCreate.Open;
  while not qFormCreate.Eof do begin
    ActionDescription := UpperCase(qFormCreate.FieldByName('Description').AsString);
    if (Pos('UPDATE', ActionDescription) > 0) then
      AuditActionUpdate := qFormCreate.FieldByName('id').AsString
    else if (Pos('DELETE', ActionDescription) > 0) then
      AuditActionDelete := qFormCreate.FieldByName('id').AsString
    else if (Pos('INSERT', ActionDescription) > 0) then
      AuditActionInsert := qFormCreate.FieldByName('id').AsString;
    qFormCreate.Next;
  end;
  qFormCreate.Close;
  qFormCreate.Free;
  lAudit := TestForAudit('tUserFunction');
end;  // FormCreate().

procedure TSysEditUserFunctionForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AmendString.Free;
  slFields.Free;
  slValues.Free;
end;  // FormClose.

procedure TSysEditUserFunctionForm.SetAppend(Value: boolean);
begin
  lAppend := Value;
  if lAppend then Caption := Caption + ' (ADD)'
  else            Caption := Caption + ' (EDIT)';
end;  // SetAppend.

procedure TSysEditUserFunctionForm.SetUserID(Value: integer);
begin
  sUserID := IntToStr(Value);
end;  // SetUserID.

function TSysEditUserFunctionForm.GetUserID: integer;
begin
  Result := StrToInt(sUserID);
end;  // GetUserID.

procedure TSysEditUserFunctionForm.SetUserLogin(Value: string);
begin
  Original_UserLogin := Value;
  edtUserLogin.Text := Original_UserLogin;
end;  // SetUserLogin.

function TSysEditUserFunctionForm.GetUserLogin: string;
begin
  Result := edtUserLogin.Text;
end;  // GetUserLogin.

procedure TSysEditUserFunctionForm.SetPassword(Value: string);
begin
  Original_Password := Value;
  edtPassword.Text := Original_Password;
end;  // SetEdit2.

function TSysEditUserFunctionForm.GetPassword: string;
begin
  Result := edtPassword.Text;
end;  // GetEdit2.

procedure TSysEditUserFunctionForm.SetFirstName(Value: string);
begin
  Original_FirstName := Value;
  edtFirstName.Text := Original_FirstName;
end;  // SetFirstName.

function TSysEditUserFunctionForm.GetFirstName: string;
begin
  Result := edtFirstName.Text;
end;  // GetFirstName.

procedure TSysEditUserFunctionForm.SetSurname(Value: string);
begin
  Original_Surname := Value;
  edtSurname.Text := Original_Surname;
end;  // SetSurname.

function TSysEditUserFunctionForm.GetSurname: string;
begin
  Result := edtSurname.Text;
end;  // GetSurname.

procedure TSysEditUserFunctionForm.SetFunction(Value: string);
var
  sTemp : string;
  lTruncated : boolean;
begin
  sTemp := Value;
  // Only 16-digit integer tolerated.
  ProveInteger(sTemp,lTruncated);
  if lTruncated then sTemp := Copy(sTemp+'0000000000000000',1,16);
  sFunction := sTemp;
  cbF1.Checked  := (Copy(sFunction, 1,1)<>'0');
  cbF2.Checked  := (Copy(sFunction, 2,1)<>'0');
  cbF3.Checked  := (Copy(sFunction, 3,1)<>'0');
  cbF4.Checked  := (Copy(sFunction, 4,1)<>'0');
  cbF5.Checked  := (Copy(sFunction, 5,1)<>'0');
  cbF6.Checked  := (Copy(sFunction, 6,1)<>'0');
  cbF7.Checked  := (Copy(sFunction, 7,1)<>'0');
  cbF8.Checked  := (Copy(sFunction, 8,1)<>'0');
  cbF9.Checked  := (Copy(sFunction, 9,1)<>'0');
  cbF10.Checked := (Copy(sFunction,10,1)<>'0');
  cbF11.Checked := (Copy(sFunction,11,1)<>'0');
  cbF12.Checked := (Copy(sFunction,12,1)<>'0');
  cbF13.Checked := (Copy(sFunction,13,1)<>'0');
  cbF14.Checked := (Copy(sFunction,14,1)<>'0');
  cbF15.Checked := (Copy(sFunction,15,1)<>'0');
  cbF16.Checked := (Copy(sFunction,16,1)<>'0');
  Original_ChkF1  := cbF1.Checked;
  Original_ChkF2  := cbF2.Checked;
  Original_ChkF3  := cbF3.Checked;
  Original_ChkF4  := cbF4.Checked;
  Original_ChkF5  := cbF5.Checked;
  Original_ChkF6  := cbF6.Checked;
  Original_ChkF7  := cbF7.Checked;
  Original_ChkF8  := cbF8.Checked;
  Original_ChkF9  := cbF9.Checked;
  Original_ChkF10 := cbF10.Checked;
  Original_ChkF11 := cbF11.Checked;
  Original_ChkF12 := cbF12.Checked;
  Original_ChkF13 := cbF13.Checked;
  Original_ChkF14 := cbF14.Checked;
  Original_ChkF15 := cbF15.Checked;
  Original_ChkF16 := cbF16.Checked;
end;  // SetFunction.

procedure TSysEditUserFunctionForm.btnOkClick(Sender: TObject);
var
  q: TQuery;
  sValue : string;
  lReturn : boolean;
  sAuditInsert : string;
  sAuditField : string;
  sAuditValue : string;
  AuditAction : string;
  sStarted : string;
  sError : string;
  DeleteString : TStringList;
  sCodedPassword : string;
  sUserFunction : string;
begin
  if lAppend then AuditAction := AuditActionInsert
  else            AuditAction := AuditActionUpdate;
  q := TQuery.Create(SELF);
  q.DatabaseName := 'dbPPdata';
  lReturn := True;  // default.
  if (Length(Trim(edtUserLogin.Text)) = 0) or
    (Length(Trim(edtPassword.Text)) = 0) then begin
    sError := 'UserLogin and Password MUST be completed. Try again.';
    lReturn := False;  // do not save.
  end
  else if lAppend then begin
    // Make sure that the data is not already in the table.
    q.SQL.Add('SELECT *');
    q.SQL.Add('FROM tUser');
    q.SQL.Add('WHERE UserLogin LIKE '''+Trim(edtUserLogin.Text)+'''');
    q.Open;
    lReturn := (q.Bof and q.Eof);
    q.Close;
    q.SQL.Clear;
    if not lReturn then begin             // Field value truncated - Not Okay!
      sError := 'This Operator already exists in the table.';
    end;
  end;
  if lReturn then begin
    if lAppend then begin
      // Save the User data.
//      sCodedPassword := EncodeString(Password);
      sCodedPassword := Password;
      AmendString.Add('INSERT INTO tUser');
      AmendString.Add('(UserLogin, Password, FirstName, Surname, Active)');
      AmendString.Add('VALUES ('''+ Trim(edtUserLogin.Text)+''','''+
        sCodedPassword+''',');
      if lAudit then begin
        SetAuditStart(sUserName, AuditAction, 'tUser',
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditData('USERLOGIN', '', sStarted, AuditString);
      end;  // lAudit.
      sStarted := Trim(edtFirstName.Text);
      if (Length(sStarted) = 0) then begin
        sValue := 'NULL,';
      end
      else begin
        sValue := ''''+ sStarted +''',';
        if lAudit then begin
          SetAuditData('FIRSTNAME', '', sStarted, AuditString);
        end;
      end;
      sStarted := Trim(edtSurname.Text);
      if (Length(sStarted) = 0) then begin
        sValue := sValue+'NULL, 1)';
      end
      else begin
        sValue := sValue+' '''+ sStarted +''', 1)';
        if lAudit then begin
          SetAuditData('SURNAME', '', sStarted, AuditString);
          SetAuditData('ACTIVE', '', '1', AuditString);
        end;
      end;
//      AmendString.Add(sField);
      AmendString.Add(sValue);
      // Save the new tUser details.
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        // Get and store the new ID for this table.
        with q do begin
          SQL.Clear;
          SQL.Add('SELECT ID');
          SQL.ADD('FROM tUser');
          SQL.Add('WHERE UserLogin LIKE '''+ UserLogin +'''');
          SQL.Add('AND Active = 1');
          Open;
          SetAuditID(FieldByName('ID').AsString, sAuditValue);
          Close;
        end;
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
{
      if lAudit and (Length(Audit_TrailDesc) > 0) then begin
        sAuditField := sAuditField +',Description)';
        sAuditValue := sAuditValue +',';
        Audit_TrailDesc := Copy(Audit_TrailDesc,2,Length(Audit_TrailDesc)-1);
        Audit_TrailDesc := ''''+Audit_TrailDesc+''')';
        AuditString.Add(sAuditField);
        AuditString.Add(sAuditValue);
        AuditString.Add(Audit_TrailDesc);
        q.SQL := AuditString;
        q.ExecSQL;
}
      end;  // lAudit.

      // Retrieve the resulting UserID value.
      AmendString.Clear;
      AmendString.Add('SELECT id');
      AmendString.Add('FROM tUser');
      AmendString.Add('WHERE UserLogin LIKE '''+ UserLogin +'''');
      AmendString.Add('AND Active = 1');
      q.SQL := AmendString;
      q.Open;
      if (q.Eof and q.Bof) then
        lReturn := False
      else
        sUserFunction := 'VALUES ('+ IntToStr(q.FieldByName('id').AsInteger)+', ';
      q.Close;

      // Now save the selected User Function values.
      if lReturn then begin
        AmendString.Clear;
        AmendString.Add('INSERT INTO tUserFunction'); // 0.
        AmendString.Add('(UserID, FunctionID)');      // 1.
        AmendString.Add(sUserFunction);               // 2 (changed below).
        q.SQL := AmendString;
{
        if lAudit then begin
          // Now add auditing to the tUserFunction table.
          sAuditInsert := '';
          sAuditField := '';
          sAuditValue := '';
          AuditString.Clear;
          SetAuditStart(sUserName, AuditAction, 'tUserFunction',
            sAuditInsert, sAuditField, sAuditValue);
// Wrong 1st param:          SetAuditID(sUserFunction, sAuditValue);
        end;  // lAudit.
}
        if cbF1.Checked then begin                    // cbF1.
          q.SQL.Strings[2] := sUserFunction+'1)';
          q.ExecSQL;
{
          if lAudit then begin
            // Get and store the new ID for this table.
            with q do begin
              SQL.Clear;
              SQL.Add('SELECT ID');
              SQL.ADD('FROM tUser');
              SQL.Add('WHERE UserLogin LIKE '''+ UserLogin +'''');
              SQL.Add('AND Active = 1');
              Open;
              SetAuditID(FieldByName('ID').AsString, sAuditValue);
              Close;
            end;
            SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
            SetAuditData('FUNCTIONID', '', '1', AuditString);
          end;
}
        end;  // cbF1.
        if cbF2.Checked then begin                    // cbF2.
          q.SQL.Strings[2] := sUserFunction+'2)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '2', AuditString);
          end;
}
        end;  // cbF2.
        if cbF3.Checked then begin                    // cbF3.
          q.SQL.Strings[2] := sUserFunction+'3)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '3', AuditString);
          end;
}
        end;  // cbF3.
        if cbF4.Checked then begin                    // cbF4.
          q.SQL.Strings[2] := sUserFunction+'4)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '4', AuditString);
          end;
}
        end;  // cbF4.
        if cbF5.Checked then begin                    // cbF5.
          q.SQL.Strings[2] := sUserFunction+'5)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '5', AuditString);
          end;
}
        end;  // cbF5.
        if cbF6.Checked then begin                    // cbF6.
          q.SQL.Strings[2] := sUserFunction+'6)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '6', AuditString);
          end;
}
        end;  // cbF6.
        if cbF7.Checked then begin                    // cbF7.
          q.SQL.Strings[2] := sUserFunction+'7)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '7', AuditString);
          end;
}
        end;  // cbF7.
        if cbF8.Checked then begin                    // cbF8.
          q.SQL.Strings[2] := sUserFunction+'8)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '8', AuditString);
          end;
}
        end;  // cbF8.
        if cbF9.Checked then begin                    // cbF9.
          q.SQL.Strings[2] := sUserFunction+'9)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '9', AuditString);
          end;
}
        end;  // cbF9.
        if cbF10.Checked then begin                   // cbF10.
          q.SQL.Strings[2] := sUserFunction+'10)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '10', AuditString);
          end;
}
        end;  // cbF10.
        if cbF11.Checked then begin                   // cbF11.
          q.SQL.Strings[2] := sUserFunction+'11)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '11', AuditString);
          end;
}
        end;  // cbF11.
        if cbF12.Checked then begin                   // cbF12.
          q.SQL.Strings[2] := sUserFunction+'12)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '12', AuditString);
          end;
}
        end;  // cbF12.
        if cbF13.Checked then begin                   // cbF13.
          q.SQL.Strings[2] := sUserFunction+'13)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '13', AuditString);
          end;
}
        end;  // cbF13.
        if cbF14.Checked then begin                   // cbF14.
          q.SQL.Strings[2] := sUserFunction+'14)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '14', AuditString);
          end;
}
        end;  // cbF14.
        if cbF15.Checked then begin                   // cbF15.
          q.SQL.Strings[2] := sUserFunction+'15)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '15', AuditString);
          end;
}
        end;  // cbF15.
        if cbF16.Checked then begin                   // cbF16.
          q.SQL.Strings[2] := sUserFunction+'16)';
          q.ExecSQL;
{
          if lAudit then begin
            SetAuditData('FUNCTIONID', '', '16', AuditString);
          end;
}
        end;  // cbF16.
        if lAudit then begin
          SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
{
        if lAudit and (Length(Audit_TrailDesc) > 0) then begin
          SetAuditData('USERID', '',
            Copy(sUserFunction,9,Length(sUserFunction)-10), Audit_TrailDesc);
          sAuditField := sAuditField +',Description)';
          sAuditValue := sAuditValue +',';
          Audit_TrailDesc := Copy(Audit_TrailDesc,2,Length(Audit_TrailDesc)-1);
          Audit_TrailDesc := ''''+Audit_TrailDesc+''')';
          AuditString.Add(sAuditField);
          AuditString.Add(sAuditValue);
          AuditString.Add(Audit_TrailDesc);
          q.SQL := AuditString;
          q.ExecSQL;
}
        end;  // lAudit.
      end;  // lReturn.
    end
    else if (Length(sUserID)=0) or (StrToInt(sUserID)<1) then begin
      sError := 'Invalid UserID value - Must be positive.';
      lReturn := False;
    end
    else begin  // not lAppend.
      AmendString.Add('UPDATE tUser');
      sStarted := Trim(edtUserLogin.Text);
      AmendString.Add('SET UserLogin = '''+ sStarted +''',');
      if lAudit then begin
{
        SetAuditSelect(sUserName, AuditAction, 'tUser',
          AuditString, sAuditField, sAuditValue);
        sAuditField := sAuditField + ', TableID';
        sAuditValue := sAuditValue + ', '+ sUserID;
}
        SetAuditStart(sUserName, AuditAction, 'tUser',
          sAuditInsert, sAuditField, sAuditValue);
        SetAuditID(sUserID, sAuditValue);
        if (sStarted <> Original_UserLogin) then begin
          SetAuditData('USERLOGIN', Original_UserLogin, sStarted, AuditString);
        end;
      end;  // lAudit.
      sStarted := Trim(edtPassword.Text);
      AmendString.Add('Password = '''+ sStarted +''',');
      if lAudit and (sStarted <> Original_Password) then begin
        SetAuditData('PASSWORD', Original_Password, sStarted, AuditString);
      end;
      sStarted := Trim(edtFirstName.Text);
      if (Length(sStarted) = 0) then begin
        AmendString.Add(' FirstName = NULL,');
      end
      else begin
        AmendString.Add(' FirstName = '''+ sStarted +''',');
      end;
      if lAudit and (sStarted <> Original_FirstName) then begin
        SetAuditData('FIRSTNAME', Original_FirstName, sStarted, AuditString);
      end;
      sStarted := Trim(edtSurname.Text);
      if (Length(sStarted) = 0) then begin
        AmendString.Add(' Surname = NULL');
      end
      else begin
        AmendString.Add(' Surname = '''+ sStarted +'''');
      end;
      if lAudit and (sStarted <> Original_Surname) then begin
        SetAuditData('SURNAME', Original_Surname, sStarted, AuditString);
      end;
      AmendString.Add('WHERE id = '+ sUserID);
      q.SQL := AmendString;
      q.ExecSQL;
      if lAudit then begin
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.

      // Now save the selected User Function values.
      DeleteString := TStringList.Create;
      DeleteString.Add('DELETE tUserFunction');
      DeleteString.Add('WHERE UserID = '+sUserID);
      DeleteString.Add('AND FunctionID = 0');
      AmendString.Clear;
      AmendString.Add('INSERT INTO tUserFunction');   // 0.
      AmendString.Add('(UserID, FunctionID)');        // 1.
      sUserFunction := 'VALUES ('+ sUserID+', ';
      AmendString.Add(sUserFunction);                 // 2 (change below).
      if lAudit then begin
        // Now add auditing to the tUserFunction table.
        sAuditInsert := '';
        sAuditField := '';
        sAuditValue := '';
        AuditString.Clear;
{
        SetAuditSelect(sUserName, AuditAction, 'tUserFunction',
          AuditString, sAuditField, sAuditValue);
}
        SetAuditStart(sUserName, AuditAction, 'tUserFunction',
          sAuditInsert, sAuditField, sAuditValue);
      end;  // lAudit.
//      sStarted := Copy(sFunction,1,1);                                // cbF1.
      if cbF1.Checked and not Original_ChkF1 then begin               // cbF1.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '1)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '1', AuditString);
        end;
      end
      else if not cbF1.Checked and Original_ChkF1 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 1';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '1', '', AuditString);
        end;
      end;  // cbF1.
      if cbF2.Checked and not Original_ChkF2 then begin               // cbF2.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '2)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '2', AuditString);
        end;
      end
      else if not cbF2.Checked and Original_ChkF2 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 2';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '2', '', AuditString);
        end;
      end;  // cbF2.
      if cbF3.Checked and not Original_ChkF3 then begin               // cbF3.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '3)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '3', AuditString);
        end;
      end
      else if not cbF3.Checked and Original_ChkF3 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 3';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '3', '', AuditString);
        end;
      end;  // cbF3.
      if cbF4.Checked and not Original_ChkF4 then begin               // cbF4.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '4)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '4', AuditString);
        end;
      end
      else if not cbF4.Checked and Original_ChkF4 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 4';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '4', '', AuditString);
        end;
      end;  // cbF4.
      if cbF5.Checked and not Original_ChkF5 then begin               // cbF5.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '5)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '5', AuditString);
        end;
      end
      else if not cbF5.Checked and Original_ChkF5 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 5';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '5', '', AuditString);
        end;
      end;  // cbF5.
      if cbF6.Checked and not Original_ChkF6 then begin               // cbF6.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '6)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '6', AuditString);
        end;
      end
      else if not cbF6.Checked and Original_ChkF6 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 6';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '6', '', AuditString);
        end;
      end;  // cbF6.
      if cbF7.Checked and not Original_ChkF7 then begin               // cbF7.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '7)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '7', AuditString);
        end;
      end
      else if not cbF7.Checked and Original_ChkF7 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 7';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '7', '', AuditString);
        end;
      end;  // cbF7.
      if cbF8.Checked and not Original_ChkF8 then begin               // cbF8.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '8)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '8', AuditString);
        end;
      end
      else if not cbF8.Checked and Original_ChkF8 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 8';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '8', '', AuditString);
        end;
      end;  // cbF8.
      if cbF9.Checked and not Original_ChkF9 then begin               // cbF9.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '9)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '9', AuditString);
        end;
      end
      else if not cbF9.Checked and Original_ChkF9 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 9';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '9', '', AuditString);
        end;
      end;  // cbF9.
      if cbF10.Checked and not Original_ChkF10 then begin             // cbF10.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '10)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '10', AuditString);
        end;
      end
      else if not cbF10.Checked and Original_ChkF10 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 10';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '10', '', AuditString);
        end;
      end;  // cbF10.
      if cbF11.Checked and not Original_ChkF11 then begin             // cbF11.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '11)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '11', AuditString);
        end;
      end
      else if not cbF11.Checked and Original_ChkF11 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 11';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '11', '', AuditString);
        end;
      end;  // cbF11.
      if cbF12.Checked and not Original_ChkF12 then begin             // cbF12.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '12)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '12', AuditString);
        end;
      end
      else if not cbF12.Checked and Original_ChkF12 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 12';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '12', '', AuditString);
        end;
      end;  // cbF12.
      if cbF13.Checked and not Original_ChkF13 then begin             // cbF13.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '13)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '13', AuditString);
        end;
      end
      else if not cbF13.Checked and Original_ChkF13 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 13';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '13', '', AuditString);
        end;
      end;  // cbF13.
      if cbF14.Checked and not Original_ChkF14 then begin             // cbF14.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '14)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '14', AuditString);
        end;
      end
      else if not cbF14.Checked and Original_ChkF14 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 14';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '14', '', AuditString);
        end;
      end;  // cbF14.
      if cbF15.Checked and not Original_ChkF15 then begin             // cbF15.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '15)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '15', AuditString);
        end;
      end
      else if not cbF15.Checked and Original_ChkF15 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 15';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '15', '', AuditString);
        end;
      end;  // cbF15.
      if cbF16.Checked and not Original_ChkF16 then begin             // cbF16.
        q.SQL := AmendString;                         // Append to table.
        q.SQL.Strings[2] := sUserFunction + '16)';
        q.ExecSQL;
        if lAudit then begin
          SetAuditData('FUNCTIONID', '', '16', AuditString);
        end;
      end
      else if not cbF16.Checked and Original_ChkF16 then begin
        q.SQL := DeleteString;                        // Delete from table.
        q.SQL.Strings[2] := 'AND FunctionID = 16';
        if lAudit then begin
          SetAuditData('FUNCTIONID', '16', '', AuditString);
        end;
        q.ExecSQL;
      end;  // cbF16.
      DeleteString.Free;
      if lAudit then begin
        SetAuditID(sUserID, sAuditValue);
        SaveAudit(sAuditInsert, sAuditField, sAuditValue, AuditString);
      end;  // lAudit.
    end;  // lAppend.
  end;  // valid minimum requirements.
  AmendString.Clear;
  slFields.Clear;
  slValues.Clear;
  q.Free;
  if lReturn then begin
    ModalResult := mrOk;
  end
  else begin
    MessageDlg(sError, mtWarning, [mbOk], 0);
  end;  // lReturn.
end;  // btnOkClick.

end.
